// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// InputIdentityDocument represents TL type `inputIdentityDocument#7cf00afe`.
type InputIdentityDocument struct {
	// Document number; 1-24 characters
	Number string
	// Document expiry date; pass null if not applicable
	ExpiryDate Date
	// Front side of the document
	FrontSide InputFileClass
	// Reverse side of the document; only for driver license and identity card; pass null
	// otherwise
	ReverseSide InputFileClass
	// Selfie with the document; pass null if unavailable
	Selfie InputFileClass
	// List of files containing a certified English translation of the document
	Translation []InputFileClass
}

// InputIdentityDocumentTypeID is TL type id of InputIdentityDocument.
const InputIdentityDocumentTypeID = 0x7cf00afe

// Ensuring interfaces in compile-time for InputIdentityDocument.
var (
	_ bin.Encoder     = &InputIdentityDocument{}
	_ bin.Decoder     = &InputIdentityDocument{}
	_ bin.BareEncoder = &InputIdentityDocument{}
	_ bin.BareDecoder = &InputIdentityDocument{}
)

func (i *InputIdentityDocument) Zero() bool {
	if i == nil {
		return true
	}
	if !(i.Number == "") {
		return false
	}
	if !(i.ExpiryDate.Zero()) {
		return false
	}
	if !(i.FrontSide == nil) {
		return false
	}
	if !(i.ReverseSide == nil) {
		return false
	}
	if !(i.Selfie == nil) {
		return false
	}
	if !(i.Translation == nil) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (i *InputIdentityDocument) String() string {
	if i == nil {
		return "InputIdentityDocument(nil)"
	}
	type Alias InputIdentityDocument
	return fmt.Sprintf("InputIdentityDocument%+v", Alias(*i))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*InputIdentityDocument) TypeID() uint32 {
	return InputIdentityDocumentTypeID
}

// TypeName returns name of type in TL schema.
func (*InputIdentityDocument) TypeName() string {
	return "inputIdentityDocument"
}

// TypeInfo returns info about TL type.
func (i *InputIdentityDocument) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "inputIdentityDocument",
		ID:   InputIdentityDocumentTypeID,
	}
	if i == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Number",
			SchemaName: "number",
		},
		{
			Name:       "ExpiryDate",
			SchemaName: "expiry_date",
		},
		{
			Name:       "FrontSide",
			SchemaName: "front_side",
		},
		{
			Name:       "ReverseSide",
			SchemaName: "reverse_side",
		},
		{
			Name:       "Selfie",
			SchemaName: "selfie",
		},
		{
			Name:       "Translation",
			SchemaName: "translation",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (i *InputIdentityDocument) Encode(b *bin.Buffer) error {
	if i == nil {
		return fmt.Errorf("can't encode inputIdentityDocument#7cf00afe as nil")
	}
	b.PutID(InputIdentityDocumentTypeID)
	return i.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (i *InputIdentityDocument) EncodeBare(b *bin.Buffer) error {
	if i == nil {
		return fmt.Errorf("can't encode inputIdentityDocument#7cf00afe as nil")
	}
	b.PutString(i.Number)
	if err := i.ExpiryDate.Encode(b); err != nil {
		return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field expiry_date: %w", err)
	}
	if i.FrontSide == nil {
		return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field front_side is nil")
	}
	if err := i.FrontSide.Encode(b); err != nil {
		return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field front_side: %w", err)
	}
	if i.ReverseSide == nil {
		return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field reverse_side is nil")
	}
	if err := i.ReverseSide.Encode(b); err != nil {
		return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field reverse_side: %w", err)
	}
	if i.Selfie == nil {
		return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field selfie is nil")
	}
	if err := i.Selfie.Encode(b); err != nil {
		return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field selfie: %w", err)
	}
	b.PutInt(len(i.Translation))
	for idx, v := range i.Translation {
		if v == nil {
			return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field translation element with index %d is nil", idx)
		}
		if err := v.EncodeBare(b); err != nil {
			return fmt.Errorf("unable to encode bare inputIdentityDocument#7cf00afe: field translation element with index %d: %w", idx, err)
		}
	}
	return nil
}

// Decode implements bin.Decoder.
func (i *InputIdentityDocument) Decode(b *bin.Buffer) error {
	if i == nil {
		return fmt.Errorf("can't decode inputIdentityDocument#7cf00afe to nil")
	}
	if err := b.ConsumeID(InputIdentityDocumentTypeID); err != nil {
		return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: %w", err)
	}
	return i.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (i *InputIdentityDocument) DecodeBare(b *bin.Buffer) error {
	if i == nil {
		return fmt.Errorf("can't decode inputIdentityDocument#7cf00afe to nil")
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: field number: %w", err)
		}
		i.Number = value
	}
	{
		if err := i.ExpiryDate.Decode(b); err != nil {
			return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: field expiry_date: %w", err)
		}
	}
	{
		value, err := DecodeInputFile(b)
		if err != nil {
			return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: field front_side: %w", err)
		}
		i.FrontSide = value
	}
	{
		value, err := DecodeInputFile(b)
		if err != nil {
			return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: field reverse_side: %w", err)
		}
		i.ReverseSide = value
	}
	{
		value, err := DecodeInputFile(b)
		if err != nil {
			return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: field selfie: %w", err)
		}
		i.Selfie = value
	}
	{
		headerLen, err := b.Int()
		if err != nil {
			return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: field translation: %w", err)
		}

		if headerLen > 0 {
			i.Translation = make([]InputFileClass, 0, headerLen%bin.PreallocateLimit)
		}
		for idx := 0; idx < headerLen; idx++ {
			value, err := DecodeInputFile(b)
			if err != nil {
				return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: field translation: %w", err)
			}
			i.Translation = append(i.Translation, value)
		}
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (i *InputIdentityDocument) EncodeTDLibJSON(b tdjson.Encoder) error {
	if i == nil {
		return fmt.Errorf("can't encode inputIdentityDocument#7cf00afe as nil")
	}
	b.ObjStart()
	b.PutID("inputIdentityDocument")
	b.Comma()
	b.FieldStart("number")
	b.PutString(i.Number)
	b.Comma()
	b.FieldStart("expiry_date")
	if err := i.ExpiryDate.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field expiry_date: %w", err)
	}
	b.Comma()
	b.FieldStart("front_side")
	if i.FrontSide == nil {
		return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field front_side is nil")
	}
	if err := i.FrontSide.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field front_side: %w", err)
	}
	b.Comma()
	b.FieldStart("reverse_side")
	if i.ReverseSide == nil {
		return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field reverse_side is nil")
	}
	if err := i.ReverseSide.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field reverse_side: %w", err)
	}
	b.Comma()
	b.FieldStart("selfie")
	if i.Selfie == nil {
		return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field selfie is nil")
	}
	if err := i.Selfie.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field selfie: %w", err)
	}
	b.Comma()
	b.FieldStart("translation")
	b.ArrStart()
	for idx, v := range i.Translation {
		if v == nil {
			return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field translation element with index %d is nil", idx)
		}
		if err := v.EncodeTDLibJSON(b); err != nil {
			return fmt.Errorf("unable to encode inputIdentityDocument#7cf00afe: field translation element with index %d: %w", idx, err)
		}
		b.Comma()
	}
	b.StripComma()
	b.ArrEnd()
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (i *InputIdentityDocument) DecodeTDLibJSON(b tdjson.Decoder) error {
	if i == nil {
		return fmt.Errorf("can't decode inputIdentityDocument#7cf00afe to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("inputIdentityDocument"); err != nil {
				return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: %w", err)
			}
		case "number":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: field number: %w", err)
			}
			i.Number = value
		case "expiry_date":
			if err := i.ExpiryDate.DecodeTDLibJSON(b); err != nil {
				return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: field expiry_date: %w", err)
			}
		case "front_side":
			value, err := DecodeTDLibJSONInputFile(b)
			if err != nil {
				return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: field front_side: %w", err)
			}
			i.FrontSide = value
		case "reverse_side":
			value, err := DecodeTDLibJSONInputFile(b)
			if err != nil {
				return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: field reverse_side: %w", err)
			}
			i.ReverseSide = value
		case "selfie":
			value, err := DecodeTDLibJSONInputFile(b)
			if err != nil {
				return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: field selfie: %w", err)
			}
			i.Selfie = value
		case "translation":
			if err := b.Arr(func(b tdjson.Decoder) error {
				value, err := DecodeTDLibJSONInputFile(b)
				if err != nil {
					return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: field translation: %w", err)
				}
				i.Translation = append(i.Translation, value)
				return nil
			}); err != nil {
				return fmt.Errorf("unable to decode inputIdentityDocument#7cf00afe: field translation: %w", err)
			}
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetNumber returns value of Number field.
func (i *InputIdentityDocument) GetNumber() (value string) {
	if i == nil {
		return
	}
	return i.Number
}

// GetExpiryDate returns value of ExpiryDate field.
func (i *InputIdentityDocument) GetExpiryDate() (value Date) {
	if i == nil {
		return
	}
	return i.ExpiryDate
}

// GetFrontSide returns value of FrontSide field.
func (i *InputIdentityDocument) GetFrontSide() (value InputFileClass) {
	if i == nil {
		return
	}
	return i.FrontSide
}

// GetReverseSide returns value of ReverseSide field.
func (i *InputIdentityDocument) GetReverseSide() (value InputFileClass) {
	if i == nil {
		return
	}
	return i.ReverseSide
}

// GetSelfie returns value of Selfie field.
func (i *InputIdentityDocument) GetSelfie() (value InputFileClass) {
	if i == nil {
		return
	}
	return i.Selfie
}

// GetTranslation returns value of Translation field.
func (i *InputIdentityDocument) GetTranslation() (value []InputFileClass) {
	if i == nil {
		return
	}
	return i.Translation
}
